/*
 * CHECK-UTILS : chkbasdwidth
 * chkbandwidth is check current bandwidth on server
 *
 * $Id: chkbandwidth.h,v 1.5 2006/01/18 14:09:09 oops Exp $
 */

#include <interface.h>

#ifdef HAVE_GETOPT_LONG
static struct option long_options [] = {
	/* Options without arguments: */
	{ "help", no_argument, NULL, 'h' },
	{ "vervose", no_argument, NULL, 'v' },
	{ "interactive", no_argument, NULL, 'c' },

	/* Options accepting an argument: */
	{ "interface", required_argument, NULL, 'i' },
	{ "seconds", required_argument, NULL, 's' },
	{ "unit", required_argument, NULL, 'u' },
	{ 0, 0, 0, 0 }
};
#endif

struct packets {
	off_t in;
	off_t out;
};

struct configs {
	int second;
	short unitarg;
	short usages;
	char unit[5];
	char iface[8];
	short nocurses;
};

//int devicelist (char *list);
int iface_info (struct interface *, char *);
void getValue (char *in, char *out, char *dev);
void usage (char *prog);
void printResult (char *dev, int units, int sec, int noansi, int r);
void removeBuffer (int r);
void interface_free (struct interface *);

extern void cb_init (void);
extern void cb_exit (int s);
extern int cb_getch (char *buf);
extern void cb_get_terminal_size(void);
extern char * field_string (char *text, int col);

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
