/*
 * CHECK-UTILS curses code
 *
 * $Id: my_curses.c,v 1.2 2006/01/18 14:09:09 oops Exp $
 */
#include "my_curses.h"

extern struct scrsize sc;
extern struct interface ifs;

void cb_init (void) {
	curses_open = 1;
	initscr ();
	start_color ();
	init_pair (COLOR_DEF, COLOR_WHITE, COLOR_BLACK);
	init_pair (COLOR_BANNER, COLOR_WHITE, COLOR_CYAN);
	init_pair (COLOR_INOUT, COLOR_BLUE, COLOR_BLACK);
	nonl ();
	noecho ();
	cbreak ();
}

void cb_exit (int s) {
	if ( curses_open )
		endwin ();

	interface_free (&ifs);

	exit (1);
}

int cb_getch (char *buf) {
	int r;
	fflush (stdout);
	r = read (STDIN_FILENO, buf, 1);
	tcflush (STDIN_FILENO, TCIFLUSH);

	return r;
}

void cb_get_terminal_size(void) {
	struct winsize w;
	if (ioctl(2, TIOCGWINSZ, &w) == 0) {
		if (w.ws_row > 0)
			sc.height = w.ws_row;
		if (w.ws_col > 0)
			sc.width = w.ws_col;
	}
}
