/*
 * OS (linux) dependency code on chkbandwidth
 * $Id: chkbandwidth_os.c,v 1.2 2006/01/18 14:09:09 oops Exp $
 */
#define DEVFILE "/proc/net/dev"

int iface_info (struct interface *p, char *iface) {
	FILE *fp;
	int i;
	char buf[512] = { 0, };

	if ( (fp = fopen (DEVFILE, "rb")) == NULL ) {
		fprintf (stderr, _("Can't open %s in read mode"), DEVFILE);
		return 0;
	}

	/* skip 2 line, cause useless information */
	for ( i=0; i<2; i++ )
		fgets (buf, sizeof (buf), fp);

	i = 0;
	while ( fgets (buf, sizeof (buf), fp) ) {
		char *bufname = NULL;
		char *bufdata;

		/* number of linux eternet is latter than 256 */
		if ( i > DEVICEMAX ) {
			interface_free (p);
			cb_exit (0);
		}

		if ( (bufdata = strchr (buf, ':')) == NULL )
			continue;

		/* get interface name */
		if ( iface != NULL ) {
			buf[bufdata-buf] = 0;
			bufname = trim (buf);

			if ( ! strcmp (bufname, iface) )
				p->dev = i;
		}

		/* get various information of interface */
		bufdata++;

		if ( iface != NULL ) {
			p->ifname[i] = malloc (sizeof (char) * (strlen (bufname) + 1));
			p->in[i]  = malloc (sizeof (char) * 32);
			p->out[i] = malloc (sizeof (char) * 32);

			strcpy (p->ifname[i], bufname);
		}

		strcpy (p->in[i], field_string (bufdata, 1));
		strcpy (p->out[i], field_string (bufdata, 9));

		i++;
	}

	fclose (fp);

	p->ifname[i] = NULL;
	p->in[i]     = NULL;
	p->out[i]	 = NULL;

	return (p->dev < 0 && iface != NULL) ? -1 : i;
}

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
